Index: trunk/src/rasapi32/initterm.cpp
===================================================================
--- trunk/src/rasapi32/initterm.cpp	(revision 772)
+++ trunk/src/rasapi32/initterm.cpp	(revision 772)
@@ -0,0 +1,104 @@
+/* $Id: initterm.cpp,v 1.1 1999-09-01 07:28:46 sandervl Exp $ */
+
+/*
+ * DLL entry point
+ *
+ * Copyright 1998 Sander van Leeuwen
+ * Copyright 1998 Peter Fitzsimmons
+ *
+ *
+ * Project Odin Software License can be found in LICENSE.TXT
+ *
+ */
+
+/*-------------------------------------------------------------*/
+/* INITERM.C -- Source for a custom dynamic link library       */
+/*              initialization and termination (_DLL_InitTerm) */
+/*              function.                                      */
+/*                                                             */
+/* When called to perform initialization, this sample function */
+/* gets storage for an array of integers, and initializes its  */
+/* elements with random integers.  At termination time, it     */
+/* frees the array.  Substitute your own special processing.   */
+/*-------------------------------------------------------------*/
+
+
+/* Include files */
+#define  INCL_DOSMODULEMGR
+#define  INCL_DOSPROCESS
+#include <os2wrap.h>    //Odin32 OS/2 api wrappers
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <odin.h>
+#include <misc.h>       /*PLF Wed  98-03-18 23:18:15*/
+
+extern "C" {
+void CDECL _ctordtorInit( void );
+void CDECL _ctordtorTerm( void );
+}
+
+/*-------------------------------------------------------------------*/
+/* A clean up routine registered with DosExitList must be used if    */
+/* runtime calls are required and the runtime is dynamically linked. */
+/* This will guarantee that this clean up routine is run before the  */
+/* library DLL is terminated.                                        */
+/*-------------------------------------------------------------------*/
+static void APIENTRY cleanup(ULONG reason);
+
+
+/****************************************************************************/
+/* _DLL_InitTerm is the function that gets called by the operating system   */
+/* loader when it loads and frees this DLL for each process that accesses   */
+/* this DLL.  However, it only gets called the first time the DLL is loaded */
+/* and the last time it is freed for a particular process.  The system      */
+/* linkage convention MUST be used because the operating system loader is   */
+/* calling this function.                                                   */
+/****************************************************************************/
+unsigned long SYSTEM _DLL_InitTerm(unsigned long hModule, unsigned long
+                                   ulFlag)
+{
+   size_t i;
+   APIRET rc;
+
+   /*-------------------------------------------------------------------------*/
+   /* If ulFlag is zero then the DLL is being loaded so initialization should */
+   /* be performed.  If ulFlag is 1 then the DLL is being freed so            */
+   /* termination should be performed.                                        */
+   /*-------------------------------------------------------------------------*/
+
+   switch (ulFlag) {
+      case 0 :
+         _ctordtorInit();
+
+         CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
+
+         /*******************************************************************/
+         /* A DosExitList routine must be used to clean up if runtime calls */
+         /* are required and the runtime is dynamically linked.             */
+         /*******************************************************************/
+
+         rc = DosExitList(0x0000F000|EXLST_ADD, cleanup);
+         if(rc)
+                return 0UL;
+
+         break;
+      case 1 :
+         break;
+      default  :
+         return 0UL;
+   }
+
+   /***********************************************************/
+   /* A non-zero value must be returned to indicate success.  */
+   /***********************************************************/
+   return 1UL;
+}
+
+
+static void APIENTRY cleanup(ULONG ulReason)
+{
+   _ctordtorTerm();
+   DosExitList(EXLST_EXIT, cleanup);
+   return ;
+}
Index: trunk/src/rasapi32/makefile
===================================================================
--- trunk/src/rasapi32/makefile	(revision 772)
+++ trunk/src/rasapi32/makefile	(revision 772)
@@ -0,0 +1,51 @@
+# $Id: makefile,v 1.1 1999-09-01 07:28:46 sandervl Exp $
+
+#
+# PD-Win32 API
+#
+#	rasapi32.dll makefile
+#
+
+PDWIN32_INCLUDE = ..\..\include
+PDWIN32_LIB = ..\..\lib
+PDWIN32_BIN = ..\..\bin
+
+
+!include $(PDWIN32_INCLUDE)/pdwin32.mk
+
+
+CFLAGS = $(CFLAGS) -I$(PDWIN32_INCLUDE) /DNONAMELESSUNION
+CXXFLAGS = $(CXXFLAGS) -I$(PDWIN32_INCLUDE) /DNONAMELESSUNION
+
+
+TARGET = rasapi32
+
+OBJS =  rasapi32.obj initterm.obj
+
+all: $(TARGET).dll $(TARGET).lib
+
+
+$(TARGET).dll: $(OBJS) $(TARGET).def
+	$(LD) $(LDFLAGS) -Fm -Fe$@ $(OBJS) $(TARGET).def \
+              $(PDWIN32_LIB)/pmwinx.lib $(PDWIN32_LIB)/kernel32.lib \
+              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
+	$(CP) $@ $(PDWIN32_BIN)
+
+
+$(TARGET).lib: $(TARGET).dll
+	$(IMPLIB) $(IMPLIBFLAGS) $@ $(TARGET).dll
+	$(CP) $@ $(PDWIN32_LIB)
+
+
+initterm.obj: initterm.cpp
+rasapi32.obj: rasapi32.cpp
+
+clean:
+	$(RM) *.obj *.lib *.dll *~ *.map *.pch	
+	$(RM) $(PDWIN32_BIN)\$(TARGET).dll
+	$(RM) $(PDWIN32_LIB)\$(TARGET).lib
+
+
+
+
+
Index: trunk/src/rasapi32/rasapi32.DEF
===================================================================
--- trunk/src/rasapi32/rasapi32.DEF	(revision 772)
+++ trunk/src/rasapi32/rasapi32.DEF	(revision 772)
@@ -0,0 +1,111 @@
+; $Id: rasapi32.DEF,v 1.1 1999-09-01 07:28:46 sandervl Exp $
+
+;Created by BLAST for IBM's compiler
+LIBRARY RASAPI32 INITINSTANCE
+DATA MULTIPLE NONSHARED
+
+EXPORTS
+   ;RnaEngineRequest@500
+   ;DialEngineRequest@501
+   ;SuprvRequest@502
+   ;DialInMessage@503
+   ;RnaEnumConnEntries@504
+   ;RnaGetConnEntry@505
+   ;RnaFreeConnEntry@506
+   ;RnaSaveConnEntry@507
+   ;RnaDeleteConnEntry@508
+   ;RnaRenameConnEntry@509
+   ;RnaValidateEntryName@510
+   ;RnaEnumDevices@511
+   ;RnaGetDeviceInfo@512
+   ;RnaGetDefaultDevConfig@513
+   ;RnaBuildDevConfig@514
+   ;RnaDevConfigDlg@515
+   ;RnaFreeDevConfig@516
+   ;RnaActivateEngine@517
+   ;RnaDeactivateEngine@518
+   ;SuprvEnumAccessInfo@519
+   ;SuprvGetAccessInfo@520
+   ;SuprvSetAccessInfo@521
+   ;SuprvGetAdminConfig@522
+   ;SuprvInitialize@523
+   ;SuprvDeInitialize@524
+   ;RnaUIDial@525
+   ;RnaImplicitDial@526
+   ;RasDial16@527
+   ;RnaSMMInfoDialog@528
+   ;RnaEnumerateMacNames@529
+   ;RnaEnumCountryInfo@530
+   ;RnaGetAreaCodeList@531
+   ;RnaFindDriver@532
+   ;RnaInstallDriver@533
+   ;RnaGetDialSettings@534
+   ;RnaSetDialSettings@535
+   ;RnaGetIPInfo@536
+   ;RnaSetIPInfo@537
+   ;RnaGetCurrentCountry@538
+   ;RnaEnumerateSMMNames@539
+   ;RnaGetDefaultSMMInfo@540
+   ;ClAdvDevDlgProc@541
+   ;RnaExportEntry@542
+   ;RnaImportEntry@543
+   ;RnaValidateImportEntry@544
+   ;RnaGetMultiLinkInfo@545
+   ;RnaSetMultiLinkInfo@546
+   ;RnaGetSubEntry@547
+   ;RnaSetSubEntry@548
+   ;RnaGetDeviceChannel@549
+   RasConnectionNotificationA	= _RasConnectionNotificationA@12	@550
+   RasConnectionNotificationW	= _RasConnectionNotificationW@12	@551
+   ;RasValidateEntryName@552
+   ;RasRenameEntry@553
+   ;RasDeleteEntry@554
+   ;RasGetEntryProperties@555
+   ;RasSetEntryProperties@556
+   ;RasEnumDevices@557
+   ;RasGetCountryInfo@558
+   RasCreatePhonebookEntryA	= _RasCreatePhonebookEntryA@8	@559
+   RasCreatePhonebookEntryW	= _RasCreatePhonebookEntryW@8	@560
+   RasDialA			= _RasDialA@24			@561
+   RasDialW			= _RasDialW@24			@562
+   RasEditPhonebookEntryA	= _RasEditPhonebookEntryA@12	@563
+   RasEditPhonebookEntryW	= _RasEditPhonebookEntryW@12	@564
+   RasEnumConnectionsA		= _RasEnumConnectionsA@12	@565
+   RasEnumConnectionsW		= _RasEnumConnectionsW@12	@566
+   RasEnumEntriesA		= _RasEnumEntriesA@20		@567
+   RasEnumEntriesW		= _RasEnumEntriesW@20		@568
+   RasGetConnectStatusA		= _RasGetConnectStatusA@8	@569
+   RasGetConnectStatusW		= _RasGetConnectStatusW@8	@570
+   RasGetEntryDialParamsA	= _RasGetEntryDialParamsA@12	@571
+   RasGetEntryDialParamsW	= _RasGetEntryDialParamsW@12	@572
+   RasGetErrorStringA		= _RasGetErrorStringA@12	@573
+   RasGetErrorStringW		= _RasGetErrorStringW@12	@574
+   RasGetProjectionInfoA	= _RasGetProjectionInfoA@16	@575
+   RasGetProjectionInfoW	= _RasGetProjectionInfoW@16	@576
+   RasHangUpA			= _RasHangUpA@4			@577
+   RasHangUpW			= _RasHangUpW@4			@578
+   RasSetEntryDialParamsA	= _RasSetEntryDialParamsA@12	@579
+   RasSetEntryDialParamsW	= _RasSetEntryDialParamsW@12	@580
+   ;RnaCloseMac@581
+   ;RnaComplete@582
+   ;RnaGetDevicePort@583
+   ;RnaGetOverlaidSMM@584
+   ;RnaGetUserProfile@585
+   ;RnaOpenMac@586
+   ;RnaSessInitialize@587
+   ;RnaStartCallback@588
+   ;RnaTerminate@589
+   ;RnaUICallbackDialog@590
+   ;RnaUIUsernamePassword@591
+
+   RasValidateEntryNameA	= _RasValidateEntryNameA@8	@612
+   RasRenameEntryA		= _RasRenameEntryA@12		@613
+   RasDeleteEntryA		= _RasDeleteEntryA@8		@614
+   RasGetEntryPropertiesA	= _RasGetEntryPropertiesA@24	@615
+   RasSetEntryPropertiesA	= _RasSetEntryPropertiesA@24	@616
+   RasEnumDevicesA		= _RasEnumDevicesA@12		@617
+   RasGetCountryInfoA		= _RasGetCountryInfoA@8		@618
+
+   ;RnaStartServer@700
+   ;RnaStopServer@701
+   ;RnaConfigureServer@702
Index: trunk/src/rasapi32/rasapi32.cpp
===================================================================
--- trunk/src/rasapi32/rasapi32.cpp	(revision 772)
+++ trunk/src/rasapi32/rasapi32.cpp	(revision 772)
@@ -0,0 +1,274 @@
+/* $Id: rasapi32.cpp,v 1.1 1999-09-01 07:28:46 sandervl Exp $ */
+/*
+ * RASAPI32
+ * 
+ * Copyright 1998 Marcus Meissner
+ * Copyright 1999 Jens Wiessner
+ */
+
+/*	At the moment, these are only empty stubs.
+ */
+
+#include <os2win.h>
+#include <ras.h>
+#include "debugtools.h"
+#include <debugdefs.h>
+
+
+DEFAULT_DEBUG_CHANNEL(ras)
+
+
+
+/**************************************************************************
+ *                 RasConnectionNotification32A	[RASAPI32.550]
+ */
+DWORD APIENTRY RasConnectionNotificationA( HRASCONN hras, HANDLE handle, DWORD dword )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasConnectionNotification32W	[RASAPI32.551]
+ */
+DWORD APIENTRY RasConnectionNotificationW( HRASCONN hras, HANDLE handle, DWORD dword )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasCreatePhonebookEntry32A	[RASAPI32.559]
+ */
+DWORD APIENTRY RasCreatePhonebookEntryA( HWND hwnd, LPSTR lpstr)
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasCreatePhonebookEntry32W	[RASAPI32.560]
+ */
+DWORD APIENTRY RasCreatePhonebookEntryW( HWND hwnd, LPWSTR lpwstr )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasDial32A			[RASAPI32.561]
+ */
+DWORD APIENTRY RasDialA( LPRASDIALEXTENSIONS rasdial, LPSTR str, LPRASDIALPARAMSA rasdial2, DWORD dword, LPVOID lpv, LPHRASCONN rascon )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasDial32W			[RASAPI32.562]
+ */
+DWORD APIENTRY RasDialW( LPRASDIALEXTENSIONS rasdial, LPWSTR str, LPRASDIALPARAMSW rasdial2, DWORD dword, LPVOID lpv, LPHRASCONN rascon )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasEditPhonebookEntry32A	[RASAPI32.563]
+ */
+DWORD APIENTRY RasEditPhonebookEntryA( HWND hwnd, LPSTR str, LPSTR str2 )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasEditPhonebookEntry32W	[RASAPI32.564]
+ */
+DWORD APIENTRY RasEditPhonebookEntryW( HWND hwnd, LPWSTR str, LPWSTR str2 )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasEnumConnections32A	[RASAPI32.565]
+ */
+DWORD WINAPI RasEnumConnectionsA( LPRASCONNA rca, LPDWORD x, LPDWORD y)
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasEnumConnections32W	[RASAPI32.566]
+ */
+DWORD APIENTRY RasEnumConnectionsW( LPRASCONNW rca, LPDWORD x, LPDWORD y )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasEnumEntries32A		[RASAPI32.567]
+ */
+DWORD APIENTRY RasEnumEntriesA( LPSTR str, LPSTR str2, LPRASENTRYNAMEA rasentry, 
+		LPDWORD lpdw, LPDWORD lpdw2 )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasEnumEntries32W		[RASAPI32.568]
+ */
+DWORD APIENTRY RasEnumEntriesW( LPWSTR str, LPWSTR str2, LPRASENTRYNAMEW rasentry,
+		LPDWORD lpdw, LPDWORD lpdw2 )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasGetConnectStatus32A	[RASAPI32.569]
+ */
+DWORD APIENTRY RasGetConnectStatusA( HRASCONN hras, LPRASCONNSTATUSA rascon )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasGetConnectStatus32W	[RASAPI32.570]
+ */
+DWORD APIENTRY RasGetConnectStatusW( HRASCONN rasconn, LPRASCONNSTATUSW connstat )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasGetEntryDialParams32A	[RASAPI32.571]
+ */
+DWORD APIENTRY RasGetEntryDialParamsA( LPSTR str, LPRASDIALPARAMSA dialparm, LPBOOL lpb)
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasGetEntryDialParams32W	[RASAPI32.572]
+ */
+DWORD APIENTRY RasGetEntryDialParamsW( LPWSTR str, LPRASDIALPARAMSW dialparm, LPBOOL lpb )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasGetErrorString32A		[RASAPI32.573]
+ */
+DWORD APIENTRY RasGetErrorStringA( UINT uint, LPSTR str, DWORD dword )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasGetErrorString32W		[RASAPI32.574]
+ */
+DWORD APIENTRY RasGetErrorStringW( UINT uint, LPWSTR str, DWORD dword )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasGetProjectionInfo32A	[RASAPI32.575]
+ */
+DWORD APIENTRY RasGetProjectionInfoA( HRASCONN rascon, RASPROJECTION rasprj, 
+		LPVOID lpv, LPDWORD lpdw )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasGetProjectionInfo32W	[RASAPI32.576]
+ */
+DWORD APIENTRY RasGetProjectionInfoW( HRASCONN rascon, RASPROJECTION rasprj, 
+		LPVOID lpv, LPDWORD lpdw )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasHangUp32A			[RASAPI32.577]
+ */
+DWORD APIENTRY RasHangUpA( HRASCONN hras )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasHangUp32W			[RASAPI32.578]
+ */
+DWORD APIENTRY RasHangUpW( HRASCONN hras )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasSetEntryDialParams32A	[RASAPI32.579]
+ */
+DWORD APIENTRY RasSetEntryDialParamsA( LPSTR str, LPRASDIALPARAMSA rasdp, BOOL bo )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasSetEntryDialParams32W	[RASAPI32.580]
+ */
+DWORD APIENTRY RasSetEntryDialParamsW( LPWSTR str, LPRASDIALPARAMSW rasdp, BOOL bo)
+{
+	return 0;
+}
+
+
+
+/**************************************************************************
+ *                 RasValidateEntryName32A	[RASAPI32.612]
+ */
+DWORD APIENTRY RasValidateEntryNameA( LPSTR str, LPSTR str2)
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasRenameEntry32A		[RASAPI32.613]
+ */
+DWORD APIENTRY RasRenameEntryA( LPSTR str, LPSTR str2, LPSTR str3 )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasDeleteEntry32A		[RASAPI32.614]
+ */
+DWORD APIENTRY RasDeleteEntryA( LPSTR str, LPSTR str2)
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasGetEntryProperties32A	[RASAPI32.615]
+ */
+DWORD APIENTRY RasGetEntryPropertiesA( LPSTR str, LPSTR str2, LPRASENTRYA rasentry, LPDWORD dword, LPBYTE pbyte, LPDWORD dword2 )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasSetEntryProperties32A	[RASAPI32.616]
+ */
+DWORD APIENTRY RasSetEntryPropertiesA( LPSTR str, LPSTR str2, LPRASENTRYA rasentry, DWORD dword, LPBYTE pbyte, DWORD dword2 )
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasEnumDevices32A		[RASAPI32.617]
+ */
+DWORD APIENTRY RasEnumDevicesA( LPRASDEVINFOA rasdevinfo, LPDWORD dword, LPDWORD dword2)
+{
+	return 0;
+}
+
+/**************************************************************************
+ *                 RasGetCountryInfo32A		[RASAPI32.618]
+ */
+DWORD APIENTRY RasGetCountryInfoA( LPRASCTRYINFOA rasctryinfo, LPDWORD dword )
+{
+	return 0;
+}