Index: /trunk/kBuild/env.sh
===================================================================
--- /trunk/kBuild/env.sh	(revision 781)
+++ /trunk/kBuild/env.sh	(revision 782)
@@ -5,5 +5,5 @@
 # Environment setup script.
 #
-# Copyright (c) 2005 knut st. osmundsen <bird@innotek.de>
+# Copyright (c) 2005-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/envos2.cmd
===================================================================
--- /trunk/kBuild/envos2.cmd	(revision 781)
+++ /trunk/kBuild/envos2.cmd	(revision 782)
@@ -8,5 +8,5 @@
  * Environment setup script for OS/2.
  *
- * Copyright (c) 1999-2006 knut st. osmundsen <bird-kbuild-src@anduin.net>
+ * Copyright (c) 1999-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
  *
  *
Index: /trunk/kBuild/envwin.cmd
===================================================================
--- /trunk/kBuild/envwin.cmd	(revision 781)
+++ /trunk/kBuild/envwin.cmd	(revision 782)
@@ -5,5 +5,5 @@
 REM # Environment setup script.
 REM #
-REM # Copyright (c) 2005-2006 knut st. osmundsen <bird@innotek.de>
+REM # Copyright (c) 2005-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 REM #
 REM #
@@ -106,10 +106,10 @@
 
 :illegal_target
-echo error: BUILD_TARGET=%BUILD_TARGET is no longer valid. 
+echo error: BUILD_TARGET=%BUILD_TARGET is no longer valid.
 echo        Only 'win' and 'nt' are permitted for targeting microsoft windows.
 goto failed
 
 :illegal_platform
-echo error: BUILD_PLATFORM=%BUILD_PLATFORM is no longer valid. 
+echo error: BUILD_PLATFORM=%BUILD_PLATFORM is no longer valid.
 echo        Only 'win' and 'nt' are permitted for building on microsoft windows.
 goto failed
Index: /trunk/kBuild/footer.kmk
===================================================================
--- /trunk/kBuild/footer.kmk	(revision 781)
+++ /trunk/kBuild/footer.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild - File included at top of makefile.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/gnumake-footer.kmk
===================================================================
--- /trunk/kBuild/gnumake-footer.kmk	(revision 781)
+++ /trunk/kBuild/gnumake-footer.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild - Additional footer for use when bootstrapping kBuild using Vanilla GNU Make.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/gnumake-header.kmk
===================================================================
--- /trunk/kBuild/gnumake-header.kmk	(revision 781)
+++ /trunk/kBuild/gnumake-header.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild - Additional header for use when bootstrapping kBuild using Vanilla GNU Make.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
@@ -34,5 +34,5 @@
 
 ##
-# Pushes an item onto a 'stack' variable. 
+# Pushes an item onto a 'stack' variable.
 # @param    $1   The stack variable name
 # @param    $2   What to push.
@@ -47,5 +47,5 @@
 ##
 # Removes the top element from a 'stack' variable.
-# This does *NOT* return the top element, use 
+# This does *NOT* return the top element, use
 # @param    $1   The stack variable name
 # @remark This ain't very fast (that's why it's implemented in functions.c in kmk).
@@ -70,5 +70,5 @@
 endif
 endef
-									
+
 _DEFAULT_VARIABLES := .LIBPATTERNS .VARIABLES AR ARFLAGS AS CC CHECKOUT,v CO COFLAGS COMPILE.C COMPILE.F COMPILE.S COMPILE.c COMPILE.cc COMPILE.cpp COMPILE.def COMPILE.f COMPILE.mod COMPILE.p COMPILE.r COMPILE.s CPP CTANGLE CWEAVE CXX F77 F77FLAGS FC GET LD LEX LEX.l LINK.C LINK.F LINK.S LINK.c LINK.cc LINK.cpp LINK.f LINK.o LINK.p LINK.r LINK.s LINT LINT.c M2C MAKEINFO OUTPUT_OPTION PC PREPROCESS.F PREPROCESS.S PREPROCESS.r RM TANGLE TEX TEXI2DVI WEAVE YACC YACC.y
 $(foreach i, $(_DEFAULT_VARIABLES), $(eval $(call def_undefine_default,$(i))))
Index: /trunk/kBuild/header.kmk
===================================================================
--- /trunk/kBuild/header.kmk	(revision 781)
+++ /trunk/kBuild/header.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild - File included at top of makefile.
 #
-# Copyright (c) 2004-2007 knut st. osmundsen <bird-src-spam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/rules.kmk
===================================================================
--- /trunk/kBuild/rules.kmk	(revision 781)
+++ /trunk/kBuild/rules.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild - File included at top of makefile.
 #
-# Copyright (c) 2004 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/DXSDK.kmk
===================================================================
--- /trunk/kBuild/sdks/DXSDK.kmk	(revision 781)
+++ /trunk/kBuild/sdks/DXSDK.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild SDK - The Microsoft Direct X SDK, targeting $(BUILD_TARGET).
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/DXSDKAMD64.kmk
===================================================================
--- /trunk/kBuild/sdks/DXSDKAMD64.kmk	(revision 781)
+++ /trunk/kBuild/sdks/DXSDKAMD64.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild SDK - The Microsoft Direct X SDK, targeting AMD64.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/DXSDKX86.kmk
===================================================================
--- /trunk/kBuild/sdks/DXSDKX86.kmk	(revision 781)
+++ /trunk/kBuild/sdks/DXSDKX86.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild SDK - The Microsoft Direct X SDK, targeting X86.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/LIBSDL.kmk
===================================================================
--- /trunk/kBuild/sdks/LIBSDL.kmk	(revision 781)
+++ /trunk/kBuild/sdks/LIBSDL.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild SDK - Simple DirectMedia Layer, targeting $(BUILD_TARGET).
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/NT4DDK.kmk
===================================================================
--- /trunk/kBuild/sdks/NT4DDK.kmk	(revision 781)
+++ /trunk/kBuild/sdks/NT4DDK.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild SDK - The Windows NT 4 DDK, targeting X86.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-srcspam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/W2K3DDK.kmk
===================================================================
--- /trunk/kBuild/sdks/W2K3DDK.kmk	(revision 781)
+++ /trunk/kBuild/sdks/W2K3DDK.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild SDK - The Microsoft Windows 2003 DDK, targeting $(BUILD_TARGET).
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/W2K3DDKAMD64.kmk
===================================================================
--- /trunk/kBuild/sdks/W2K3DDKAMD64.kmk	(revision 781)
+++ /trunk/kBuild/sdks/W2K3DDKAMD64.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild SDK - The Microsoft Windows 2003 DDK, targeting amd64.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/W2K3DDKX86.kmk
===================================================================
--- /trunk/kBuild/sdks/W2K3DDKX86.kmk	(revision 781)
+++ /trunk/kBuild/sdks/W2K3DDKX86.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild SDK - The Microsoft Windows 2003 DDK, targeting x86.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/W32API.kmk
===================================================================
--- /trunk/kBuild/sdks/W32API.kmk	(revision 781)
+++ /trunk/kBuild/sdks/W32API.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild SDK - w32api (MinGW), targeting x86.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-srcspam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/WIN32SDK.kmk
===================================================================
--- /trunk/kBuild/sdks/WIN32SDK.kmk	(revision 781)
+++ /trunk/kBuild/sdks/WIN32SDK.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild SDK - The Windows Platform SDK, targeting x86.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/WIN32SDK2002.kmk
===================================================================
--- /trunk/kBuild/sdks/WIN32SDK2002.kmk	(revision 781)
+++ /trunk/kBuild/sdks/WIN32SDK2002.kmk	(revision 782)
@@ -5,5 +5,5 @@
 #              Differs in that it has ddraw.lib and dxguid.lib.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/WIN64SDK.kmk
===================================================================
--- /trunk/kBuild/sdks/WIN64SDK.kmk	(revision 781)
+++ /trunk/kBuild/sdks/WIN64SDK.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild SDK - The Windows Platform SDK, targeting AMD64.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/WINPSDK.kmk
===================================================================
--- /trunk/kBuild/sdks/WINPSDK.kmk	(revision 781)
+++ /trunk/kBuild/sdks/WINPSDK.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild SDK - The Windows Platform SDK, targeting (BUILD_TARGET).
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/sdks/WINPSDKINCS.kmk
===================================================================
--- /trunk/kBuild/sdks/WINPSDKINCS.kmk	(revision 781)
+++ /trunk/kBuild/sdks/WINPSDKINCS.kmk	(revision 782)
@@ -2,9 +2,9 @@
 ## @file
 #
-# kBuild SDK - The Windows Platform SDK, targeting (BUILD_TARGET) but 
-#              without any libraries or LIBPATH properties. 
+# kBuild SDK - The Windows Platform SDK, targeting (BUILD_TARGET) but
+#              without any libraries or LIBPATH properties.
 #              Basically for finding specstrings.h when using the DDK.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/subfooter.kmk
===================================================================
--- /trunk/kBuild/subfooter.kmk	(revision 781)
+++ /trunk/kBuild/subfooter.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild - File included at bottom of a makefile or sub-makefile.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/subheader.kmk
===================================================================
--- /trunk/kBuild/subheader.kmk	(revision 781)
+++ /trunk/kBuild/subheader.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild - File included at top of a makefile or sub-makefile.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
@@ -39,5 +39,5 @@
  _SUB_MAKEFILE_NOT_FIRST := 1
  include $(PATH_KBUILD)/header.kmk
- 
+
 else
 
Index: /trunk/kBuild/tools/ALP.kmk
===================================================================
--- /trunk/kBuild/tools/ALP.kmk	(revision 781)
+++ /trunk/kBuild/tools/ALP.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - ALP or later.
 #
-# Copyright (c) 2005-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2005-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
@@ -58,6 +58,6 @@
 # @param    $(objsuff)  Object suffix.
 TOOL_ALP_COMPILE_AS_OUTPUT = $(outbase).lst
-TOOL_ALP_COMPILE_AS_DEPEND = 
-TOOL_ALP_COMPILE_AS_DEPORD = 
+TOOL_ALP_COMPILE_AS_DEPEND =
+TOOL_ALP_COMPILE_AS_DEPORD =
 define TOOL_ALP_COMPILE_AS_CMDS
 	$(QUIET)$(TOOL_ALP_AS)\
Index: /trunk/kBuild/tools/GCC.kmk
===================================================================
--- /trunk/kBuild/tools/GCC.kmk	(revision 781)
+++ /trunk/kBuild/tools/GCC.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - Generic GCC Using The System GCC.
 #
-# Copyright (c) 2004-2005 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
@@ -42,5 +42,5 @@
 # General Properties used by kBuild
 TOOL_GCC_COBJSUFF         ?= .o
-TOOL_GCC_CFLAGS           ?= 
+TOOL_GCC_CFLAGS           ?=
 TOOL_GCC_CFLAGS.debug     ?= -g
 TOOL_GCC_CFLAGS.profile   ?= -g -O2 #-pg
@@ -51,5 +51,5 @@
 TOOL_GCC_CXXOBJSUFF       ?= .o
 TOOL_GCC_CXXOBJSUFF       ?= .o
-TOOL_GCC_CXXFLAGS         ?= 
+TOOL_GCC_CXXFLAGS         ?=
 TOOL_GCC_CXXFLAGS.debug   ?= -g -O0
 TOOL_GCC_CXXFLAGS.profile ?= -g -O2 #-pg
Index: /trunk/kBuild/tools/GCC3.kmk
===================================================================
--- /trunk/kBuild/tools/GCC3.kmk	(revision 781)
+++ /trunk/kBuild/tools/GCC3.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - Generic GCC v3.2.x or later Using The System GCC.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/GCC32.kmk
===================================================================
--- /trunk/kBuild/tools/GCC32.kmk	(revision 781)
+++ /trunk/kBuild/tools/GCC32.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - Generic 32-bit GCC v3.2.x or later Using The System GCC.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/GCC3OMF.kmk
===================================================================
--- /trunk/kBuild/tools/GCC3OMF.kmk	(revision 781)
+++ /trunk/kBuild/tools/GCC3OMF.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - GCC v3 targeting OS/2 OMF.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/GCC4MACHO.kmk
===================================================================
--- /trunk/kBuild/tools/GCC4MACHO.kmk	(revision 781)
+++ /trunk/kBuild/tools/GCC4MACHO.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - GCC v4 targeting Darwin (Mac OS X) Mach-o.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/MINGW32.kmk
===================================================================
--- /trunk/kBuild/tools/MINGW32.kmk	(revision 781)
+++ /trunk/kBuild/tools/MINGW32.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - MinGW32 GCC v3.3+.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/NASM.kmk
===================================================================
--- /trunk/kBuild/tools/NASM.kmk	(revision 781)
+++ /trunk/kBuild/tools/NASM.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - Netwide Assembler v0.98+.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/TAR.kmk
===================================================================
--- /trunk/kBuild/tools/TAR.kmk	(revision 781)
+++ /trunk/kBuild/tools/TAR.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - tar unpacker.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/TARGZ.kmk
===================================================================
--- /trunk/kBuild/tools/TARGZ.kmk	(revision 781)
+++ /trunk/kBuild/tools/TARGZ.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - tar.gz unpacker.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/VCC70.kmk
===================================================================
--- /trunk/kBuild/tools/VCC70.kmk	(revision 781)
+++ /trunk/kBuild/tools/VCC70.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - Visual C++ 7.0 (aka Visual Studio .NET), targeting x86.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/VCC80.kmk
===================================================================
--- /trunk/kBuild/tools/VCC80.kmk	(revision 781)
+++ /trunk/kBuild/tools/VCC80.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - Visual C++ 8.0 (aka Visual .NET 2005, or MSC v14), targeting $(BUILD_TARGET).
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <fbird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/VCC80AMD64.kmk
===================================================================
--- /trunk/kBuild/tools/VCC80AMD64.kmk	(revision 781)
+++ /trunk/kBuild/tools/VCC80AMD64.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - Visual C++ 8.0 (aka Visual .NET 2005, or MSC v14), targeting AMD64.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/VCC80X86.kmk
===================================================================
--- /trunk/kBuild/tools/VCC80X86.kmk	(revision 781)
+++ /trunk/kBuild/tools/VCC80X86.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - Visual C++ 8.0 (aka Visual .NET 2005, or MSC v14), targeting x86.
 #
-# Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/WGET.kmk
===================================================================
--- /trunk/kBuild/tools/WGET.kmk	(revision 781)
+++ /trunk/kBuild/tools/WGET.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - wget fetchers.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/XGCCAMD64LINUX.kmk
===================================================================
--- /trunk/kBuild/tools/XGCCAMD64LINUX.kmk	(revision 781)
+++ /trunk/kBuild/tools/XGCCAMD64LINUX.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - GCC Cross compiler for AMD64+Linux.
 #
-# Copyright (c) 2004-2005 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2004-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/YASM.kmk
===================================================================
--- /trunk/kBuild/tools/YASM.kmk	(revision 781)
+++ /trunk/kBuild/tools/YASM.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - YASM 0.4.0 or later.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/tools/ZIP.kmk
===================================================================
--- /trunk/kBuild/tools/ZIP.kmk	(revision 781)
+++ /trunk/kBuild/tools/ZIP.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild Tool Config - The zip/unzip packer/unpacker.
 #
-# Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2006-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
Index: /trunk/kBuild/up.kmk
===================================================================
--- /trunk/kBuild/up.kmk	(revision 781)
+++ /trunk/kBuild/up.kmk	(revision 782)
@@ -4,5 +4,5 @@
 # kBuild - File included at top of a up forwarder makefile.
 #
-# Copyright (c) 2005 knut st. osmundsen <bird-srcspam@anduin.net>
+# Copyright (c) 2005-2007 knut st. osmundsen <bird-kBuild-spam@anduin.net>
 #
 #
@@ -30,6 +30,6 @@
 
 UP_TO ?= ..
-	
-# typical kbuild goals.		
+
+# typical kbuild goals.
 all_recursive \
 binaries \