Index: /trunk/src/3rdparty/os2/xsystray/README
===================================================================
--- /trunk/src/3rdparty/os2/xsystray/README	(revision 836)
+++ /trunk/src/3rdparty/os2/xsystray/README	(revision 837)
@@ -2,5 +2,5 @@
 Version 0.1.0
 
-Copyright (C) 2009 Dmitry A. Kuminov
+Copyright (C) 2009-2011 Dmitriy Kuminov
 
 Extended system tray widget is free software; you can redistribute it
Index: /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.c
===================================================================
--- /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.c	(revision 836)
+++ /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.c	(revision 837)
@@ -6,5 +6,5 @@
  *      Implementation of the public API.
  *
- *      Copyright (C) 2009 Dmitry A. Kuminov
+ *      Copyright (C) 2009-2011 Dmitriy Kuminov
  *
  *      This file is part of the Extended system tray widget source package.
@@ -240,20 +240,4 @@
 }
 
-/*
- *@@ xstQuerySysTrayVersion:
- *
- *      Returns the version of the Extended system tray in the variables pointed
- *      to by arguments. Any argument may be NULL in which case the
- *      corresponding component of the version is not returned.
- *
- *      Returns TRUE on success and FALSE if the Extended system tray is not
- *      installed or not operational.
- *
- *      NOTE: When the Extended system tray is started up or gets enabled after
- *      being temporarily disabled, it sends a message with the ID returned by
- *      xstGetSysTrayCreatedMsgId() to all top-level WC_FRAME windows on the
- *      desktop to let them add tray icons if they need.
- */
-
 BOOL xstQuerySysTrayVersion(PULONG pulMajor,    // out: major version number
                             PULONG pulMinor,    // out: minor version number
@@ -283,45 +267,4 @@
     return brc;
 }
-
-/*
- *@@ xstAddSysTrayIcon:
- *
- *      Adds an icon for the given window handle to the system tray. The icon ID
- *      is used to distinguish between several icons for the same window handle.
- *      If the icon with the specified ID already exists in the system tray, it
- *      will be replaced.
- *
- *      Returns TRUE on success and FALSE otherwise.
- *
- *      The specified window handle receives notification messages about icon
- *      events using the message ID specified by the ulMsgId parameter. The
- *      layout of the message parameters is as follows:
- *
- *          param1
- *              USHORT  usIconID        icon ID
- *              USHORT  usNotifyCode    notify code, one of XST_IN_ constants
- *
- *          param2
- *              PVOID   pData           notify code specific data (see below)
- *
- *      The following notify codes are currently recognized:
- *
- *          XST_IN_MOUSE:
- *              Mouse event in the icon area. Currently, only mouse click
- *              messages are recognized. param2 is a pointer to the XSTMOUSEMSG
- *              structure containing full mouse message details.
- *
- *          XST_IN_CONTEXT:
- *              Context menu event in the icon area. param2 is a pointer to the
- *              XSTCONTEXTMSG structure containing full message details.
- *
- *          XST_IN_WHEEL:
- *              Mouse wheel event in the icon area. param2 is a pointer to the
- *              XSTWHEELTMSG structure containing full message details.
- *
- *      NOTE: The maximum tooltip text length (including terminating null) is
- *      limited to a value returned by xstGetSysTrayMaxTextLen(). If the
- *      supplied string is longer, it will be truncated.
- */
 
 BOOL xstAddSysTrayIcon(HWND hwnd,       // in: window handle associated with the icon
@@ -443,13 +386,4 @@
 }
 
-/*
- *@@ xstReplaceSysTrayIcon:
- *
- *      Replaces the existing icon previously added by xstAddSysTrayIcon() with
- *      a new icon.
- *
- *      Returns TRUE on success and FALSE otherwise.
- */
-
 BOOL xstReplaceSysTrayIcon(HWND hwnd,        // in: window handle associated with the icon
                            USHORT usId,      // in: icon ID to change
@@ -484,13 +418,4 @@
     return brc;
 }
-
-/*
- *@@ xstRemoveSysTrayIcon:
- *
- *      Removes the icon previously added by xstAddSysTrayIcon() from the system
- *      tray.
- *
- *      Returns TRUE on success and FALSE otherwise.
- */
 
 BOOL xstRemoveSysTrayIcon(HWND hwnd,    // in: window handle associated with the icon
@@ -542,21 +467,4 @@
 }
 
-/*
- *@@ xstSetSysTrayIconToolTip:
- *
- *      Sets the tooltip text for the given icon in the system tray. This text
- *      is shown when the mouse pointer is held still over the icon area for
- *      some time.
- *
- *      If pszText is NULL, the tooltip text is reset and will not be shown next
- *      time. The old tooltip is hidden if it is being currently shown.
- *
- *      Returns TRUE on success and FALSE otherwise.
- *
- *      NOTE: The maximum tooltip text length (including terminating null) is
- *      limited to a value returned by xstGetSysTrayMaxTextLen(). If the
- *      supplied string is longer, it will be truncated.
- */
-
 BOOL xstSetSysTrayIconToolTip(HWND hwnd,        // in: window handle associated with the icon
                               USHORT usId,      // in: icon ID to set the tooltip for
@@ -602,12 +510,4 @@
 }
 
-/*
- *@@ xstQuerySysTrayIconRect:
- *
- *      Obtains a rectangle occupied by the given icon (in screen coordinates,
- *      top right corner exclusive).
- *
- *      Returns TRUE on success and FALSE otherwise.
- */
 BOOL xstQuerySysTrayIconRect(HWND hwnd, USHORT usId, PRECTL prclRect)
 {
@@ -631,16 +531,4 @@
     return brc;
 }
-
-/*
- *@@ xstGetSysTrayCreatedMsgId:
- *
- *      Returns the ID of the message that is sent by the Extended system tray
- *      to all top-level WC_FRAME windows on the desktop to let them add tray
- *      icons if they need.
- *
- *      NOTE: The returned value never changes until reboot so it is a good
- *      practice to cache it instead of calling this function each time from the
- *      window procedure of every involved window.
- */
 
 ULONG xstGetSysTrayCreatedMsgId()
@@ -652,22 +540,4 @@
 }
 
-/*
- *@@ xstGetSysTrayMaxTextLen:
- *
- *      Returns the maximum length of the text (in bytes, including the
- *      terminating null) that can be shown in the tooltop of the icon in the
- *      system tray. You can use the returned value to determine the maximum
- *      length of the string passed as pszText to xstSetSysTrayIconToolTip().
- *
- *      The returned value also defines the maximum length of both the title and
- *      the text (including terminating nulls) of the icon's balloon for the
- *      xstShowSysTrayIconBalloon() call.
- *
- *      Returns TRUE on success and FALSE otherwise.
- *
- *      NOTE: The returned value never changes until reboot so it is a good
- *      practice to cache it instead of calling this function each time.
- */
-
 ULONG xstGetSysTrayMaxTextLen()
 {
Index: /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.def
===================================================================
--- /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.def	(revision 836)
+++ /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.def	(revision 837)
@@ -5,3 +5,3 @@
 
 LIBRARY XSYSTRAY INITINSTANCE TERMINSTANCE
-DESCRIPTION '@#netlabs.org:0.1.0#@ Extended system tray API'
+DESCRIPTION '@#netlabs.org:0.1.1#@ Extended system tray API'
Index: /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.h
===================================================================
--- /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.h	(revision 836)
+++ /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.h	(revision 837)
@@ -13,5 +13,5 @@
  *      Refer to the "API" file for more details about the public API.
  *
- *      Copyright (C) 2009 Dmitry A. Kuminov
+ *      Copyright (C) 2009-2011 Dmitriy Kuminov
  *
  *      This file is part of the Extended system tray widget source package.
@@ -81,15 +81,113 @@
 } XSTWHEELMSG, *PXSTWHEELMSG;
 
+/*
+ *@@ xstQuerySysTrayVersion:
+ *
+ *      Returns the version of the Extended system tray in the variables pointed
+ *      to by arguments. Any argument may be NULL in which case the
+ *      corresponding component of the version is not returned.
+ *
+ *      Returns TRUE on success and FALSE if the Extended system tray is not
+ *      installed or not operational.
+ *
+ *      NOTE: When the Extended system tray is started up or gets enabled after
+ *      being temporarily disabled, it sends a message with the ID returned by
+ *      xstGetSysTrayCreatedMsgId() to all top-level WC_FRAME windows on the
+ *      desktop to let them add tray icons if they need.
+ */
+
 BOOL XSTAPI xstQuerySysTrayVersion(PULONG pulMajor, PULONG pulMinor,
                                    PULONG pulRevision);
-                                    
+
+/*
+ *@@ xstAddSysTrayIcon:
+ *
+ *      Adds an icon for the given window handle to the system tray. The icon ID
+ *      is used to distinguish between several icons for the same window handle.
+ *      If the icon with the specified ID already exists in the system tray, it
+ *      will be replaced.
+ *
+ *      Returns TRUE on success and FALSE otherwise.
+ *
+ *      The specified window handle receives notification messages about icon
+ *      events using the message ID specified by the ulMsgId parameter. The
+ *      layout of the message parameters is as follows:
+ *
+ *          param1
+ *              USHORT  usIconID        icon ID
+ *              USHORT  usNotifyCode    notify code, one of XST_IN_ constants
+ *
+ *          param2
+ *              PVOID   pData           notify code specific data (see below)
+ *
+ *      The following notify codes are currently recognized:
+ *
+ *          XST_IN_MOUSE:
+ *              Mouse event in the icon area. Currently, only mouse click
+ *              messages are recognized. param2 is a pointer to the XSTMOUSEMSG
+ *              structure containing full mouse message details.
+ *
+ *          XST_IN_CONTEXT:
+ *              Context menu event in the icon area. param2 is a pointer to the
+ *              XSTCONTEXTMSG structure containing full message details.
+ *
+ *          XST_IN_WHEEL:
+ *              Mouse wheel event in the icon area. param2 is a pointer to the
+ *              XSTWHEELTMSG structure containing full message details.
+ *
+ *      NOTE: The maximum tooltip text length (including terminating null) is
+ *      limited to a value returned by xstGetSysTrayMaxTextLen(). If the
+ *      supplied string is longer, it will be truncated.
+ */
+
 BOOL XSTAPI xstAddSysTrayIcon(HWND hwnd, USHORT usId, HPOINTER hIcon,
                               PCSZ pcszToolTip, ULONG ulMsgId, ULONG ulFlags);
-                               
+
+/*
+ *@@ xstReplaceSysTrayIcon:
+ *
+ *      Replaces the existing icon previously added by xstAddSysTrayIcon() with
+ *      a new icon.
+ *
+ *      Returns TRUE on success and FALSE otherwise.
+ */
+
 BOOL XSTAPI xstReplaceSysTrayIcon(HWND hwnd, USHORT usId, HPOINTER hIcon);
 
+/*
+ *@@ xstRemoveSysTrayIcon:
+ *
+ *      Removes the icon previously added by xstAddSysTrayIcon() from the system
+ *      tray.
+ *
+ *      Returns TRUE on success and FALSE otherwise.
+ */
+
 BOOL XSTAPI xstRemoveSysTrayIcon(HWND hwnd, USHORT usId);
 
+/*
+ *@@ xstSetSysTrayIconToolTip:
+ *
+ *      Sets the tooltip text for the given icon in the system tray. This text
+ *      is shown when the mouse pointer is held still over the icon area for
+ *      some time.
+ *
+ *      If pszText is NULL, the tooltip text is reset and will not be shown next
+ *      time. The old tooltip is hidden if it is being currently shown.
+ *
+ *      Returns TRUE on success and FALSE otherwise.
+ *
+ *      NOTE: The maximum tooltip text length (including terminating null) is
+ *      limited to a value returned by xstGetSysTrayMaxTextLen(). If the
+ *      supplied string is longer, it will be truncated.
+ */
+
 BOOL XSTAPI xstSetSysTrayIconToolTip(HWND hwnd, USHORT usId, PCSZ pcszToolTip);
+
+/*
+ *@@ xstShowSysTrayIconBalloon:
+ *
+ *      Not implemented yet.
+ */
 
 BOOL XSTAPI xstShowSysTrayIconBalloon(HWND hwnd, USHORT usId, PCSZ pcszTitle,
@@ -97,9 +195,54 @@
                                       ULONG ulTimeout);
 
+/*
+ *@@ xstHideSysTrayIconBalloon:
+ *
+ *      Not implemented yet.
+ */
+
 BOOL XSTAPI xstHideSysTrayIconBalloon(HWND hwnd, USHORT usId);
 
+/*
+ *@@ xstQuerySysTrayIconRect:
+ *
+ *      Obtains a rectangle occupied by the given icon (in screen coordinates,
+ *      top right corner exclusive).
+ *
+ *      Returns TRUE on success and FALSE otherwise.
+ */
+
 BOOL XSTAPI xstQuerySysTrayIconRect(HWND hwnd, USHORT usId, PRECTL prclRect);
 
+/*
+ *@@ xstGetSysTrayCreatedMsgId:
+ *
+ *      Returns the ID of the message that is sent by the Extended system tray
+ *      to all top-level WC_FRAME windows on the desktop to let them add tray
+ *      icons if they need.
+ *
+ *      NOTE: The returned value never changes until reboot so it is a good
+ *      practice to cache it instead of calling this function each time from the
+ *      window procedure of every involved window.
+ */
+
 ULONG XSTAPI xstGetSysTrayCreatedMsgId();
+
+/*
+ *@@ xstGetSysTrayMaxTextLen:
+ *
+ *      Returns the maximum length of the text (in bytes, including the
+ *      terminating null) that can be shown in the tooltop of the icon in the
+ *      system tray. You can use the returned value to determine the maximum
+ *      length of the string passed as pszText to xstSetSysTrayIconToolTip().
+ *
+ *      The returned value also defines the maximum length of both the title and
+ *      the text (including terminating nulls) of the icon's balloon for the
+ *      xstShowSysTrayIconBalloon() call.
+ *
+ *      Returns TRUE on success and FALSE otherwise.
+ *
+ *      NOTE: The returned value never changes until reboot so it is a good
+ *      practice to cache it instead of calling this function each time.
+ */
 
 ULONG XSTAPI xstGetSysTrayMaxTextLen();
Index: /trunk/src/3rdparty/os2/xsystray/plugin/w_xsystray.c
===================================================================
--- /trunk/src/3rdparty/os2/xsystray/plugin/w_xsystray.c	(revision 836)
+++ /trunk/src/3rdparty/os2/xsystray/plugin/w_xsystray.c	(revision 837)
@@ -6,5 +6,5 @@
  *      Implementation.
  *
- *      Copyright (C) 2009 Dmitry A. Kuminov
+ *      Copyright (C) 2009-2011 Dmitriy Kuminov
  *
  *      This file is part of the Extended system tray widget source package.
Index: /trunk/src/3rdparty/os2/xsystray/plugin/w_xsystray.def
===================================================================
--- /trunk/src/3rdparty/os2/xsystray/plugin/w_xsystray.def	(revision 836)
+++ /trunk/src/3rdparty/os2/xsystray/plugin/w_xsystray.def	(revision 837)
@@ -5,5 +5,5 @@
 
 LIBRARY XSYSTRAY INITGLOBAL TERMGLOBAL
-Description '@#netlabs.org:0.1.0#@ Extended system tray widget DLL for XCenter'
+Description '@#netlabs.org:0.1.1#@ Extended system tray widget DLL for XCenter'
 PROTMODE
 
Index: /trunk/src/3rdparty/os2/xsystray/plugin/w_xsystray.h
===================================================================
--- /trunk/src/3rdparty/os2/xsystray/plugin/w_xsystray.h	(revision 836)
+++ /trunk/src/3rdparty/os2/xsystray/plugin/w_xsystray.h	(revision 837)
@@ -6,5 +6,5 @@
  *      Private declarations.
  *
- *      Copyright (C) 2009 Dmitry A. Kuminov
+ *      Copyright (C) 2009-2011 Dmitriy Kuminov
  *
  *      This file is part of the Extended system tray widget source package.
@@ -28,5 +28,5 @@
 #define XSYSTRAY_VERSION_MAJOR 0
 #define XSYSTRAY_VERSION_MINOR 1
-#define XSYSTRAY_VERSION_REVISION 0
+#define XSYSTRAY_VERSION_REVISION 1
 
 #define WNDCLASS_WIDGET_XSYSTRAY_SERVER "XWPCenterExtendedSysTrayServer"